// import { databasesirefik } from "../db.js";
import { toJson } from "../helper/result.js";
import { toJsonEncrypt } from "../helper/resultencrypt.js";
import { encryptData, decryptData, encryptToken } from '../helper/encryption.js'
import baca from "../../info.json" assert { type: 'json' }
import bcrypt from 'bcrypt'
import multer from "multer"
import puppeteer from 'puppeteer';
import puppeteerextra from 'puppeteer-extra';
import pluginStealth from 'puppeteer-extra-plugin-stealth'
import { kirimwa, kirimwalogin, tesstabil } from "../helper/axios.js";
import UserAgent from 'user-agents';
import { solve } from '../helper/solvercaptcha.js';
import readline from "readline";
import { databasesirup } from "../db.js";

pluginStealth().enabledEvasions.delete("iframe.contentWindow")
puppeteerextra.use(pluginStealth())

export const getSirup = async (req, reply) => {
    const { nama_opd } = req.body
    if(nama_opd != null){
      const querymapping = "SELECT * FROM master_sirup_mapping WHERE sirup_satker_nama LIKE ?"
      const selectmapping = await databasesirup.query(querymapping, [nama_opd])
      console.log(selectmapping[0][0])
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'https://sirup.lkpp.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      const page = await browser.newPage();
      var awaldinas = 0
      var akhirdinas = 0
      var awalpenyedia = 0
      var awalpengelola = 0
      var paginasi_a = 1
      var paginasi_b = 1
      var hasilpenyedia = []
      var hasilpengelola = []
      var hasilakhir = []
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('https://sirup.lkpp.go.id/sirup/rekap/klpd/D190')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="rekapKldi_length"]', '100');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const result = await page.$eval('#rekapKldi', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          result.splice(0,2)
          const result2 = await page.$eval('#rekapKldi', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          result2.splice(0,2)
          for(var ab = 0; ab< result2.length; ab++){
            // console.log(result2[ab][1])
            if(result2[ab][1].match(nama_opd)){
              console.log(ab)
              awaldinas = ab
              akhirdinas = ab
            }
          }
          // for(var p = awaldinas; p<result2.length; p++){
          for(var p = awaldinas; p<=akhirdinas; p++){
          console.log('awaldinas : ' + p)
          /////////////////////////////////////////
          const page2 = await browser.newPage();
          await page2.goto(urlawal + result[p][2].match(/href="([^"]*)/)[1]);
          // await page2.bringToFront(); 
          await delay(1000)
          await page2.select('select[name="tblLelangLama_length"]', '100');
          await delay(1000)
          for(var f=paginasi_a;f<=Math.floor((result2[p][2] / 100) + 1);f++){
              const sub1result = await page2.$eval('#tblLelangLama', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  c.innerHTML)
                  ))
              sub1result.splice(0,1)
              const sub2result = await page2.$eval('#tblLelangLama', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  c.innerText)
                  ))
              console.log(sub2result.length - 1)
              console.log(Math.floor((result2[p][2] / 100) + 1))
              sub2result.splice(0,1)
              for(var q = awalpenyedia; q< sub2result.length - 1; q++){
              console.log('awalpenyedia : ' + q)
              await delay(1000)
              ///////////////////////////////////////
              const page3 = await browser.newPage();
              await page3.goto(urlawal + sub1result[q][1].match(/href="([^"]*)/)[1]);
              // await page2.bringToFront(); 
              // await delay(1000)
              const subsub1result = await page3.$eval('#detil > table', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  c.innerHTML)
                  ))
              // subsub1result.splice(0,1)
              var _tempsubsub2 = []
              var _tempsementara = {}
              var subsub2result 
              subsub2result = await page3.$eval('#detil > table', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  {
                    // if()
                    return c.innerText
                  })
                  ))
              for(var i =0; i< subsub2result.length; i++){
                if(subsub2result[i][0] == 'Lokasi Pekerjaan'){
                  var _temp = []
                  var a = []
                  var b = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  for(var j=0; j<a[0].length;j++){
                    hasil
                      [a[0][j]] = b[0][j]
                    
                  }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } else if(subsub2result[i][0] == 'Pengadaan Berkelanjutan atau Sustainable Public Procurement (SPP)'){
                  var _temp = []
                  var a = []
                  var b = []
                  var c = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  // console.log(_temp)
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  c.push(_temp[0][2].split('\t'))
                  // for(var j=0; j<3;j++){
                    hasil
                      [a[0][0]] = a[0][1]
                    hasil
                      [b[0][0]] = b[0][1]
                    hasil
                      [c[0][0]] = c[0][1]
                  // }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } else if(subsub2result[i][0] == 'Pemanfaatan Barang/Jasa'){
                  var _temp = []
                  var a = []
                  var b = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  for(var j=0; j<a[0].length;j++){
                    hasil
                      [a[0][j]] = b[0][j]
                    
                  }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } else if(subsub2result[i][0] == 'Jadwal Pelaksanaan Kontrak'){
                  var _temp = []
                  var a = []
                  var b = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  for(var j=0; j<a[0].length;j++){
                    hasil
                      [a[0][j]] = b[0][j]
                    
                  }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } else if(subsub2result[i][0] == 'Jadwal Pemilihan Penyedia'){
                  var _temp = []
                  var a = []
                  var b = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  for(var j=0; j<a[0].length;j++){
                    hasil
                      [a[0][j]] = b[0][j]
                    
                  }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } else if(subsub2result[i][0] == 'Sumber Dana'){
                  var _temp = []
                  var a = []
                  var b = []
                  var hasil = {}
                  _temp.push(subsub2result[i][1].split('\n'))
                  a.push(_temp[0][0].split('\t'))
                  b.push(_temp[0][1].split('\t'))
                  for(var j=0; j<a[0].length;j++){
                    hasil
                      [a[0][j]] = b[0][j]
                    
                  }
                  _tempsementara
                    [subsub2result[i][0]] = hasil
                } 
                else{
                  _tempsementara[subsub2result[i][0]] = subsub2result[i][1]
                }
              }
              //hasil
              _tempsubsub2.push(_tempsementara)
              // hasilpenyedia.push({[sub2result[q][1]]: _tempsubsub2})
              hasilpenyedia.push({
                'no': sub2result[q][0],
                'namapaket': sub2result[q][1],
                'pagu': sub2result[q][2],
                'metodepemilihanpenyedia': sub2result[q][3],
                'sumberdana': sub2result[q][4],
                'koderup': sub2result[q][5],
                'waktupemilihan': sub2result[q][6],
                'detail': _tempsubsub2})
              console.log(_tempsubsub2[0])
              console.log(_tempsubsub2[0]['Usaha Kecil'])
              const querypenyedia = "INSERT INTO master_sirup_paket_penyedia (rup,namapaket,pagu,metode_pemilihan,sumber_dana,waktu_pemilihan,nama_klpd,satker,tahun_anggaran,volume_pekerjaan,uraian_pekerjaan,spesifikasi_pekerjaan,produk_dalam_negeri,usaha_kecil,spp_aspekekonomi,spp_aspeksosial,spp_aspeklingkungan,pradipa_dipa,jenis_pengadaan,jadwal_pemanfaatan_awal,jadwal_pemanfaatan_akhir,jadwal_pelaksanaan_awal,jadwal_pelaksanaan_akhir,jadwal_pemilihan_awal,jadwal_pemilihan_akhir,tanggal_perbarui_paket,satker_id) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
              await databasesirup.query(querypenyedia, [sub2result[q][5],sub2result[q][1],sub2result[q][2],sub2result[q][3],sub2result[q][4],sub2result[q][6],_tempsubsub2[0]['Nama KLPD'],_tempsubsub2[0]['Satuan Kerja'],_tempsubsub2[0]['Tahun Anggaran'],_tempsubsub2[0]['Volume Pekerjaan'],_tempsubsub2[0]['Uraian Pekerjaan'],_tempsubsub2[0]['Spesifikasi Pekerjaan'],_tempsubsub2[0]['Produk Dalam Negeri'],_tempsubsub2[0]['Usaha Kecil'],_tempsubsub2[0]['Pengadaan Berkelanjutan atau Sustainable Public Procurement (SPP)']['Aspek Ekonomi'],_tempsubsub2[0]['Pengadaan Berkelanjutan atau Sustainable Public Procurement (SPP)']['Aspek Sosial'],_tempsubsub2[0]['Pengadaan Berkelanjutan atau Sustainable Public Procurement (SPP)']['Aspek Lingkungan'],_tempsubsub2[0]['Pra DIPA / DPA'],_tempsubsub2[0]['Jenis Pengadaan'],_tempsubsub2[0]['Pemanfaatan Barang/Jasa']['Mulai'],_tempsubsub2[0]['Pemanfaatan Barang/Jasa']['Akhir'],_tempsubsub2[0]['Jadwal Pelaksanaan Kontrak']['Mulai'],_tempsubsub2[0]['Jadwal Pelaksanaan Kontrak']['Akhir'],_tempsubsub2[0]['Jadwal Pemilihan Penyedia']['Mulai'],_tempsubsub2[0]['Jadwal Pemilihan Penyedia']['Akhir'],_tempsubsub2[0]['Tanggal Perbarui Paket'],selectmapping[0][0].skpd_id])
              const querypenyedialokasi = "INSERT INTO master_sirup_lokasi (rup,provinsi,kabupaten,detail_lokasi) VALUES (?,?,?,?)"
              await databasesirup.query(querypenyedialokasi, [sub2result[q][5],_tempsubsub2[0]['Lokasi Pekerjaan']['Provinsi'],_tempsubsub2[0]['Lokasi Pekerjaan']['Kabupaten/Kota'],_tempsubsub2[0]['Lokasi Pekerjaan']['Detail Lokasi']])
              const querypenyediasumberdana = "INSERT INTO master_sirup_sumberdana (rup,sumberdana,tahun_anggaran,klpd,mak,pagu) VALUES (?,?,?,?,?,?)"
              await databasesirup.query(querypenyediasumberdana, [sub2result[q][5],_tempsubsub2[0]['Sumber Dana']['Sumber Dana'],_tempsubsub2[0]['Sumber Dana']['T.A.'],_tempsubsub2[0]['Sumber Dana']['KLPD'],_tempsubsub2[0]['Sumber Dana']['MAK'],_tempsubsub2[0]['Sumber Dana']['Pagu']])

              await page3.close()
              /////////////////////////////////////////
              }
            await page2.waitForSelector('#tblLelangLama_next > a')
            var tombols = await page2.$("#tblLelangLama_next > a")
            await tombols.click()
            await delay(1000)
          }
          await page2.close()
          //baris kedua//
          /////////////////////////////////////////
          const page4 = await browser.newPage();
          await page4.goto(urlawal + result[p][4].match(/href="([^"]*)/)[1]);
          // await page2.bringToFront(); 
          await delay(1000)
          await page4.select('select[name="tblLelangLama_length"]', '100');
          await delay(1000)
          for(var h=paginasi_b;h<=Math.floor((result2[p][4] / 100) + 1);h++){
              const sub1result2 = await page4.$eval('#tblLelangLama', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  c.innerHTML)
                  ))
              sub1result2.splice(0,1)
              const sub2result2 = await page4.$eval('#tblLelangLama', 
                tbody => [...tbody.rows].map(r => [...r.cells]
                  .map(c =>  c.innerText)
                  ))
              sub2result2.splice(0,1)
              console.log( 'penyedia : '  + Math.floor((result2[p][2] / 100) + 1))
              console.log(sub2result2.length + 'panjang')
              for(var r=awalpengelola;r<sub2result2.length - 1;r++){ 
              console.log('awalpengelola : ' + r)
              ///////////////////////////////////////
              const page5 = await browser.newPage();
              await page5.goto(urlawal + sub1result2[r][2].match(/href="([^"]*)/)[1]);
              var aa = []
              var bb = []
              var cc = []
              var aw = []
              var ak = []
              var _tempsubsub22 = []
              var _tempsementara2 = {}
              const subsub12 = await page5.$$eval('#content > div:nth-child(3) > dl', elements => elements.map(
                  element => element.innerText)
              );
              const subsub2result2 = subsub12[0].split('\n')
              var abc = subsub2result2.slice(-4)
              // console.log(abc)
              subsub2result2.pop()
              subsub2result2.pop()
              subsub2result2.pop()
              subsub2result2.pop()
              // console.log(subsub2result2)
              subsub2result2.unshift(abc[3])
              subsub2result2.unshift(abc[2])
              subsub2result2.unshift(abc[1])
              subsub2result2.unshift(abc[0])
              // subsub2result2.push(abc)
              // subsub2result2.unshift(subsub2result2.splice(subsub2result2[subsub2result2.length - 1],1)[0])
              // subsub2result2.unshift(subsub2result2.splice(subsub2result2[subsub2result2.length - 2],1)[1])
              // subsub2result2.unshift(subsub2result2.splice(subsub2result2[subsub2result2.length - 3],1)[2])
              // subsub2result2.unshift(subsub2result2.splice(subsub2result2[subsub2result2.length - 4],1)[3])
              // console.log(subsub2result2)
              for(var x=0;x<subsub2result2.length; x++){
                
                if(subsub2result2[x].charAt(0) == ':'){
                  // console.log(subsub2result2[x].substring(0,5))
                  bb.push(subsub2result2[x])
                }
                else if(subsub2result2[x].charAt(0) == '1'){
                  // if(subsub2result2[x].charAt(1) == '.'){
                    if(subsub2result2[x].charAt(0) == '1' && subsub2result2[x].charAt(3) == 'A'){
                      cc.push(subsub2result2[x].split('\t'))
                    }else{
                      if(subsub2result2[x].charAt(0) == '1' && subsub2result2[x].charAt(4) == 'A'){
                        cc.push(subsub2result2[x].split('\t'))
                      }else{
                        bb.push(subsub2result2[x].split('\t'))
                      }
                    } 
                  // }else{
                  //   if(subsub2result2[x].charAt(0) == '1' && subsub2result2[x].charAt(4) == 'A'){
                  //     cc.push(subsub2result2[x].split('\t'))
                  //   }else{
                  //     bb.push(subsub2result2[x].split('\t'))
                  //   }
                  // }
                }
                else if(subsub2result2[x].charAt(0) == '2'){
                  if(subsub2result2[x].charAt(0) == '2' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }else{
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '3'){
                  if(subsub2result2[x].charAt(0) == '3' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }else{
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '4'){
                  if(subsub2result2[x].charAt(0) == '4' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '5'){
                  if(subsub2result2[x].charAt(0) == '5' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '6'){
                  if(subsub2result2[x].charAt(0) == '6' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '7'){
                  if(subsub2result2[x].charAt(0) == '7' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '8'){
                  if(subsub2result2[x].charAt(0) == '8' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                else if(subsub2result2[x].charAt(0) == '9'){
                  if(subsub2result2[x].charAt(0) == '9' && subsub2result2[x].charAt(3) == 'A'){
                    cc.push(subsub2result2[x].split('\t'))
                  }
                }
                // else if(subsub2result2[x].charAt(0) == '10'){
                //   if(subsub2result2[x].charAt(0) == '10' && subsub2result2[x].charAt(3) == 'A'){
                //     cc.push(subsub2result2[x].split('\t'))
                //   }
                // }
                else{
                  if(subsub2result2[x].substr(0,2) == 'No' || subsub2result2[x].substr(0,2) == 'PE' || subsub2result2[x].substr(0,2) == 'To'){
                  }else{
                    aa.push(subsub2result2[x])
                  }
                }
                if(cc.length != 0){
                    bb.push(cc) 
                }
              }
            //  console.log(aa.length + ' dan ' + bb.length)
                  for(var y=0; y<aa.length;y++){
                    _tempsementara2
                      [aa[y]] = bb[y]
                  }
              //hasil
              _tempsubsub22.push(_tempsementara2)
              // console.log(_tempsubsub22)
              // hasilpengelola.push({[sub2result2[r][2]]: _tempsubsub22})
              hasilpengelola.push(
                {
                  'no': sub2result2[r][0],
                  'kegiatan': sub2result2[r][1],
                  'paket': sub2result2[r][2],
                  'pagu': sub2result2[r][3],
                  'sumberdana': sub2result2[r][4],
                  'koderup': sub2result2[r][5],
                  'waktu': sub2result2[r][6],
                  'detail': _tempsubsub22})
              console.log('masuk lo')
              // console.log(_tempsubsub22[0]['KLDI'])
              console.log(sub2result2[r][5],sub2result2[r][1],sub2result2[r][2],sub2result2[r][3],sub2result2[r][6],_tempsubsub22[0]['KLDI'],_tempsubsub22[0]['Satuan Kerja'],_tempsubsub22[0]['Tipe Swakelola'],_tempsubsub22[0]['Penyelenggara Swakelola'],_tempsubsub22[0]['Tahun Anggaran'],_tempsubsub22[0]['Volume'],_tempsubsub22[0]['Lokasi'],_tempsubsub22[0]['Deskripsi'],_tempsubsub22[0]['Awal'],_tempsubsub22[0]['Akhir'],selectmapping[0][0].skpd_id)
              const querypengelola = "INSERT INTO master_sirup_paket_pengelola(rup,kegiatan,paket,pagu,waktu,kldi,satuan_kerja,tipe_swakelola,penyelenggara_swakelola,tahun_anggaran,volume,lokasi,deskripsi,pelaksanaan_awal,pelaksaan_akhir,satker_id) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
              console.log('masuk 2')
              await databasesirup.query(querypengelola, [sub2result2[r][5],sub2result2[r][1],sub2result2[r][2],sub2result2[r][3],sub2result2[r][6],_tempsubsub22[0]['KLDI'].slice(2),_tempsubsub22[0]['Satuan Kerja'].slice(2),_tempsubsub22[0]['Tipe Swakelola'].slice(2),_tempsubsub22[0]['Penyelenggara Swakelola'].slice(2),_tempsubsub22[0]['Tahun Anggaran'].slice(2),_tempsubsub22[0]['Volume'].slice(2),_tempsubsub22[0]['Lokasi'].slice(2),_tempsubsub22[0]['Deskripsi'].slice(2),_tempsubsub22[0]['Awal'].slice(2),_tempsubsub22[0]['Akhir'].slice(2),selectmapping[0][0].skpd_id])
              console.log('masuk 1')
              const querypengelolalokasi = "INSERT INTO master_sirup_lokasi (rup,provinsi,kabupaten,detail_lokasi) VALUES (?,?,?,?)"
              await databasesirup.query(querypengelolalokasi, [sub2result2[r][5],_tempsubsub22[0]['Lokasi Pekerjaan'][1],_tempsubsub22[0]['Lokasi Pekerjaan'][2],_tempsubsub22[0]['Lokasi Pekerjaan'][3]])
              console.log('xyz : ' + _tempsubsub22[0]['SUMBER DANA'])
              for(var xyz=0;xyz<_tempsubsub22[0]['SUMBER DANA'].length;xyz++){
                console.log(_tempsubsub22[0]['SUMBER DANA'][xyz][1])
                const querypengelolasumberdana = "INSERT INTO master_sirup_sumberdana (rup,sumberdana,tahun_anggaran,klpd,mak,pagu) VALUES (?,?,?,?,?,?)"
                await databasesirup.query(querypengelolasumberdana, [sub2result2[r][5],_tempsubsub22[0]['SUMBER DANA'][xyz][1],'',_tempsubsub22[0]['SUMBER DANA'][xyz][2],_tempsubsub22[0]['SUMBER DANA'][xyz][3],_tempsubsub22[0]['SUMBER DANA'][xyz][4]]) 
              }
              await page5.close()
              }
            await page4.waitForSelector('#tblLelangLama_next > a')
            var tombols = await page4.$("#tblLelangLama_next > a")
            await tombols.click()
            await delay(1000)
          }
          await page4.close()
          hasilakhir.push({'OPD' : result2[p][1].replace('  PA/KPA',''), 'Penyedia': hasilpenyedia, 'Pengelola': hasilpengelola})
          ///////////////////////////////////////
          }
          return toJson(reply, 200, "Hasilnya", hasilakhir)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
    }else{
      return toJson(reply, 201, "Harap masukan nama opd", [])
    }
}


export const getAmelPemilihan = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      var hasil = []
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://lpse.bondowosokab.go.id/eproc4/amel/pemilihan/detail')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="activeSatker"]', 'Semua Satuan Kerja');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          await page.select('select[name="tblpemilihandetail_length"]', '-1');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const resulttabel1 = await page.$eval('#tblpemilihandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          resulttabel1.splice(0,1)
          const resulttabel2 = await page.$eval('#tblpemilihandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          resulttabel2.splice(0,1)
          // console.log(resulttabel2)
          var _temppaketperencanaan = []
          var _temppaketpemilihan = []
          for(var x=0;x<resulttabel1.length;x++){
          console.log('mulai : ' + x)
          // for(var x=0;x<1;x++){
            const page2 = await browser.newPage();
            await page2.goto(urlawal + resulttabel1[x][2].match(/href="([^"]*)/)[1]);
            await delay(1000)
            // console.log(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`)
            var namainstansi, satuankerja, paket, metodepengadaan, pagurup, idruplama, historyrup, lokasipaket
            try{
              namainstansi = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }catch{
              namainstansi = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }
            _temppaketperencanaan.push({
              'namainstansi': namainstansi[0],
              'satuankerja': satuankerja[0],
              'paket': paket[0],
              'metodepengadaan': metodepengadaan[0],
              'pagurup': pagurup[0],
              'idruplama': idruplama[0],
              'historyrup': historyrup[0],
              'lokasipaket': lokasipaket[0]
            })
            const kodepaketpemilihan = await page2.$$eval(String.raw`#collapseTwo > div > ul > li > a`, elements => elements.map(
                  element => element.innerText)
            )
            console.log(kodepaketpemilihan.length)
            for(var y=0; y<kodepaketpemilihan.length; y++){
             var kodepaket, namapaket, nilaipagupaket, nilaihps, nilaikontrak, jenistransaksi, metodepemilihan, statuspaket,tabelpenyedia, pengumumanrup, pemulihan, hasilpemilihan, kontrak, serahterima
              try{
                kodepaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }catch{
                kodepaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }
              const terakhirdiupdate = (await page2.$$eval(String.raw`body > div > div.content-wrapper > div > div > div > div > div.float-right > span`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              tabelpenyedia.splice(0,1)
              _temppaketpemilihan.push({
                'kodepaket': kodepaket[0],
                'namapaket': namapaket[0],
                'nilaipagupaket': nilaipagupaket[0],
                'nilaihps': nilaihps[0],
                'nilaikontrak': nilaikontrak[0],
                'jenistransaksi': jenistransaksi[0],
                'metodepemilihan': metodepemilihan[0],
                'statuspaket': statuspaket[0],
                'tabeldetail': tabelpenyedia,
                'pengumumanrup': pengumumanrup[0],
                'pemulihan': pemulihan[0],
                'hasilpemilihan': hasilpemilihan[0],
                'kontrak': kontrak[0],
                'serahterima': serahterima[0],
                'terakhirdiupdate': terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : ''
              })
              var _temphasil = []
              _temphasil.push(_temppaketperencanaan[0])
              _temphasil.push(_temppaketpemilihan[0])
              hasil.push({
                'idrup': resulttabel2[x][0],
                'idsatker': resulttabel2[x][1].slice(0,6),
                'satuankerja': resulttabel2[x][1],
                'namapaket': resulttabel2[x][2].split('\n')[0],
                'metodepemilihan': resulttabel2[x][3],
                'tanggalpemilihan': resulttabel2[x][4],
                'statuspaket': resulttabel2[x][5],
                'nilaihps': resulttabel2[x][6],
                'detail': _temphasil
              })
            //
            const queryinsertdetail = "INSERT INTO master_amel_detail (rup,instansi,satuan_kerja,paket,metode_pengadaan,pagu_rup,id_rup_lama,history_rup,lokasi_paket,kode_paket,nama_paket,nilai_pagu_paket,nilai_hps,nilai_kontrak,jenis_transaksi,metode_pemilihan,status_paket,nama_penyedia,npwp_penyedia,tanggal_realisasi,nilai_realisasi,jadwal_pengumuman,jadwal_pemilihan,jadwal_hasil,jadwal_kontrak,jadwal_serahterima,terakhir_diupdate, status) VALUES (?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertdetail, [resulttabel2[x][0],namainstansi[0],satuankerja[0],paket[0],metodepengadaan[0],pagurup[0],idruplama[0],historyrup[0],lokasipaket[0],kodepaket[0],namapaket[0],nilaipagupaket[0],nilaihps[0],nilaikontrak[0],jenistransaksi[0],metodepemilihan[0],statuspaket[0],tabelpenyedia.length != 0 ? tabelpenyedia[0][1] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][2] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][3] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][4] : '',pengumumanrup[0],pemulihan[0],hasilpemilihan[0],kontrak[0],serahterima[0],terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : '', 'PEMILIHAN'])
            //
            }
            const queryinsertpemilihan = "INSERT INTO master_amel_pemilihan (rup, satker_id, satker, namapaket, metode_pemilihan, tanggal_pemilihan, status_paket, nilai_hps) VALUES (?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertpemilihan, [resulttabel2[x][0],resulttabel2[x][1].slice(0,6),resulttabel2[x][1],resulttabel2[x][2].split('\n')[0],resulttabel2[x][3],resulttabel2[x][4],resulttabel2[x][5],resulttabel2[x][6]])
            console.log(x + ' selesai')
            await page2.close()
          }
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}


export const getAmelHasilPemilihan = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      var hasil = []
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://lpse.bondowosokab.go.id/eproc4/amel/hasilpemilihan/detail')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="activeSatker"]', 'Semua Satuan Kerja');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          await page.select('select[name="tblhasilpemilihandetail_length"]', '-1');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const resulttabel1 = await page.$eval('#tblhasilpemilihandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          resulttabel1.splice(0,1)
          const resulttabel2 = await page.$eval('#tblhasilpemilihandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          resulttabel2.splice(0,1)
          // console.log(resulttabel2)
          // for(var x=0;x<resulttabel1.length;x++){
          var _temppaketperencanaan = []
          var _temppaketpemilihan = []
          // for(var x=0;x<1;x++){
          for(var x=0;x<resulttabel1.length;x++){
            console.log('mulai : ' + x)
            const page2 = await browser.newPage();
            await page2.goto(urlawal + resulttabel1[x][2].match(/href="([^"]*)/)[1]);
            await delay(1000)
            // console.log(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`)
            var namainstansi, satuankerja, paket, metodepengadaan, pagurup, idruplama, historyrup, lokasipaket
            try{
              namainstansi = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }catch{
              namainstansi = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }
            _temppaketperencanaan.push({
              'namainstansi': namainstansi[0],
              'satuankerja': satuankerja[0],
              'paket': paket[0],
              'metodepengadaan': metodepengadaan[0],
              'pagurup': pagurup[0],
              'idruplama': idruplama[0],
              'historyrup': historyrup[0],
              'lokasipaket': lokasipaket[0]
            })
            const kodepaketpemilihan = await page2.$$eval(String.raw`#collapseTwo > div > ul > li > a`, elements => elements.map(
                  element => element.innerText)
            )
            console.log(kodepaketpemilihan.length)
            for(var y=0; y<kodepaketpemilihan.length; y++){
              var kodepaket, namapaket, nilaipagupaket, nilaihps, nilaikontrak, jenistransaksi, metodepemilihan, statuspaket,tabelpenyedia, pengumumanrup, pemulihan, hasilpemilihan, kontrak, serahterima
              try{
                kodepaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }catch{
                kodepaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }
              const terakhirdiupdate = (await page2.$$eval(String.raw`body > div > div.content-wrapper > div > div > div > div > div.float-right > span`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              tabelpenyedia.splice(0,1)
              _temppaketpemilihan.push({
                'kodepaket': kodepaket[0],
                'namapaket': namapaket[0],
                'nilaipagupaket': nilaipagupaket[0],
                'nilaihps': nilaihps[0],
                'nilaikontrak': nilaikontrak[0],
                'jenistransaksi': jenistransaksi[0],
                'metodepemilihan': metodepemilihan[0],
                'statuspaket': statuspaket[0],
                'tabeldetail': tabelpenyedia,
                'pengumumanrup': pengumumanrup[0],
                'pemulihan': pemulihan[0],
                'hasilpemilihan': hasilpemilihan[0],
                'kontrak': kontrak[0],
                'serahterima': serahterima[0],
                'terakhirdiupdate': terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : ''
              })
              var _temphasil = []
              _temphasil.push(_temppaketperencanaan[0])
              _temphasil.push(_temppaketpemilihan[0])
              hasil.push({
                'idrup': resulttabel2[x][0],
                'idsatker': resulttabel2[x][1].slice(0,6),
                'satuankerja': resulttabel2[x][1],
                'namapaket': resulttabel2[x][2].split('\n')[0],
                'metodepemilihan': resulttabel2[x][3],
                'tanggalpemilihan': resulttabel2[x][4],
                'statuspaket': resulttabel2[x][5],
                'nilaihps': resulttabel2[x][6],
                'detail': _temphasil
              })
            //
            const queryinsertdetail = "INSERT INTO master_amel_detail (rup,instansi,satuan_kerja,paket,metode_pengadaan,pagu_rup,id_rup_lama,history_rup,lokasi_paket,kode_paket,nama_paket,nilai_pagu_paket,nilai_hps,nilai_kontrak,jenis_transaksi,metode_pemilihan,status_paket,nama_penyedia,npwp_penyedia,tanggal_realisasi,nilai_realisasi,jadwal_pengumuman,jadwal_pemilihan,jadwal_hasil,jadwal_kontrak,jadwal_serahterima,terakhir_diupdate,status) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertdetail, [resulttabel2[x][0],namainstansi[0],satuankerja[0],paket[0],metodepengadaan[0],pagurup[0],idruplama[0],historyrup[0],lokasipaket[0],kodepaket[0],namapaket[0],nilaipagupaket[0],nilaihps[0],nilaikontrak[0],jenistransaksi[0],metodepemilihan[0],statuspaket[0],tabelpenyedia.length != 0 ? tabelpenyedia[0][1] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][2] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][3] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][4] : '',pengumumanrup[0],pemulihan[0],hasilpemilihan[0],kontrak[0],serahterima[0],terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : '', 'HASILPEMILIHAN'])
            }
            //
            const queryinserthasilpemilihan = "INSERT INTO master_amel_hasilpemilihan (rup, satker_id, satker, namapaket, metode_pemilihan, tanggal_hasil_pemilihan, status_paket, nilai_hps) VALUES (?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinserthasilpemilihan, [resulttabel2[x][0],resulttabel2[x][1].slice(0,6),resulttabel2[x][1],resulttabel2[x][2].split('\n')[0],resulttabel2[x][3],resulttabel2[x][4],resulttabel2[x][5],resulttabel2[x][6]])
            console.log(x + ' selesai')
            await page2.close()
          }
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}

export const getAmelKontrak = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      var hasil = []
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://lpse.bondowosokab.go.id/eproc4/amel/kontrak/detail')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="activeSatker"]', 'Semua Satuan Kerja');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          await page.select('select[name="tblkontrakdetail_length"]', '-1');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const resulttabel1 = await page.$eval('#tblkontrakdetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          resulttabel1.splice(0,1)
          const resulttabel2 = await page.$eval('#tblkontrakdetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          resulttabel2.splice(0,1)
          // console.log(resulttabel2)
          // for(var x=0;x<resulttabel1.length;x++){
          var _temppaketperencanaan = []
          var _temppaketpemilihan = []
          // for(var x=0;x<1;x++){
          for(var x=0;x<resulttabel1.length;x++){
          // for(var x=18;x<19;x++){
          // for(var x=19;x<resulttabel1.length;x++){
            console.log('mulai : ' + x)
            const page2 = await browser.newPage();
            await page2.goto(urlawal + resulttabel1[x][2].match(/href="([^"]*)/)[1]);
            await delay(1000)
            var namainstansi, satuankerja, paket, metodepengadaan, pagurup, idruplama, historyrup, lokasipaket
            try{
              namainstansi = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }catch{
              namainstansi = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }
            console.log(resulttabel2[x][0])
            _temppaketperencanaan.push({
              'namainstansi': namainstansi[0],
              'satuankerja': satuankerja[0],
              'paket': paket[0],
              'metodepengadaan': metodepengadaan[0],
              'pagurup': pagurup[0],
              'idruplama': idruplama[0],
              'historyrup': historyrup[0],
              'lokasipaket': lokasipaket[0]
            })
            const kodepaketpemilihan = await page2.$$eval(String.raw`#collapseTwo > div > ul > li > a`, elements => elements.map(
                  element => element.innerText)
            )
            console.log(kodepaketpemilihan.length)
            for(var y=0; y<kodepaketpemilihan.length; y++){
              var kodepaket, namapaket, nilaipagupaket, nilaihps, nilaikontrak, jenistransaksi, metodepemilihan, statuspaket,tabelpenyedia, pengumumanrup, pemulihan, hasilpemilihan, kontrak, serahterima
              try{
                kodepaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }catch{
                kodepaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }
              const terakhirdiupdate = (await page2.$$eval(String.raw`body > div > div.content-wrapper > div > div > div > div > div.float-right > span`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              tabelpenyedia.splice(0,1)
              _temppaketpemilihan.push({
                'kodepaket': kodepaket[0],
                'namapaket': namapaket[0],
                'nilaipagupaket': nilaipagupaket[0],
                'nilaihps': nilaihps[0],
                'nilaikontrak': nilaikontrak[0],
                'jenistransaksi': jenistransaksi[0],
                'metodepemilihan': metodepemilihan[0],
                'statuspaket': statuspaket[0],
                'tabeldetail': tabelpenyedia,
                'pengumumanrup': pengumumanrup[0],
                'pemulihan': pemulihan[0],
                'hasilpemilihan': hasilpemilihan[0],
                'kontrak': kontrak[0],
                'serahterima': serahterima[0],
                'terakhirdiupdate': terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : ''
              })
              var _temphasil = []
              _temphasil.push(_temppaketperencanaan[0])
              _temphasil.push(_temppaketpemilihan[0])
              console.log(resulttabel2[x])
              hasil.push({
                'idrup': resulttabel2[x][0],
                'idsatker': resulttabel2[x][1].slice(0,6),
                'satuankerja': resulttabel2[x][1],
                'namapaket': resulttabel2[x][2].split('\n')[0],
                'metodepemilihan': resulttabel2[x][3],
                'tanggalpemilihan': resulttabel2[x][4],
                'statuspaket': resulttabel2[x][5],
                'nilaikontrak': resulttabel2[x][6],
                'waktupelaksanaan': resulttabel2[x][7],
                'progresfisik': resulttabel2[x][8],
                'progresrealisasikeuangan': resulttabel2[x][9],
                'detail': _temphasil
              })
              console.log(namainstansi)
              //
              const queryinsertdetail = "INSERT INTO master_amel_detail (rup,instansi,satuan_kerja,paket,metode_pengadaan,pagu_rup,id_rup_lama,history_rup,lokasi_paket,kode_paket,nama_paket,nilai_pagu_paket,nilai_hps,nilai_kontrak,jenis_transaksi,metode_pemilihan,status_paket,nama_penyedia,npwp_penyedia,tanggal_realisasi,nilai_realisasi,jadwal_pengumuman,jadwal_pemilihan,jadwal_hasil,jadwal_kontrak,jadwal_serahterima,terakhir_diupdate, status) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
              await databasesirup.query(queryinsertdetail, [resulttabel2[x][0],namainstansi[0],satuankerja[0],paket[0],metodepengadaan[0],pagurup[0],idruplama[0],historyrup[0],lokasipaket[0],kodepaket[0],namapaket[0],nilaipagupaket[0],nilaihps[0],nilaikontrak[0],jenistransaksi[0],metodepemilihan[0],statuspaket[0],tabelpenyedia.length != 0 ? tabelpenyedia[0][1] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][2] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][3] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][4] : '',pengumumanrup[0],pemulihan[0],hasilpemilihan[0],kontrak[0],serahterima[0],terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : '', 'KONTRAK'])
              //
            }
            //
            const queryinsertkontrak = "INSERT INTO master_amel_kontrak (rup, satker_id, satker, namapaket, metode_pemilihan, tanggal_kontrak, status_paket, nilai_kontrak, waktu_pelaksanaan, progres_fisik, progres_realisasi_keuangan) VALUES (?,?,?,?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertkontrak, [resulttabel2[x][0],resulttabel2[x][1].slice(0,6),resulttabel2[x][1],resulttabel2[x][2].split('\n')[0],resulttabel2[x][3],resulttabel2[x][4],resulttabel2[x][5],resulttabel2[x][6], resulttabel2[x][7], resulttabel2[x][8], resulttabel2[x][9]])
            //
            console.log(x + ' selesai')
            await page2.close()
          }
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}


export const getSirupMapping = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'https://sirup.lkpp.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('https://sirup.lkpp.go.id/sirup/rekap/klpd/D190')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="rekapKldi_length"]', '100');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const result = await page.$eval('#rekapKldi', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          result.splice(0,2)
          const result2 = await page.$eval('#rekapKldi', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          result2.splice(0,2)
          for(var ab = 0; ab< result2.length-1; ab++){
            console.log(result2[ab][1])
            const querymapping = "SELECT * FROM master_sirup_mapping"
            const selectmapping = await databasesirup.query(querymapping, [result2[ab][1]])
            console.log(selectmapping[0][ab].sirup_satker_nama)
            // console.log(result2.length)
            if(result2[ab][1].match(selectmapping[0][ab].sirup_satker_nama)){
              console.log(result[ab][2].match(/href="([^"]*)/)[1].slice(-6))
              console.log(result[ab][4].match(/href="([^"]*)/)[1].slice(-6))
              const queryupdate = "UPDATE master_sirup_mapping SET sirup_satker_url_penyedia = ?, sirup_satker_url_pengelola = ?, satker_id = ? WHERE sirup_satker_nama = ?"
              await databasesirup.query(queryupdate, [urlawal+result[ab][2].match(/href="([^"]*)/)[1], urlawal+result[ab][4].match(/href="([^"]*)/)[1], result[ab][2].match(/href="([^"]*)/)[1].slice(-6), selectmapping[0][ab].sirup_satker_nama])
              // console.log(ab)
            }
          }
          return toJson(reply, 200, "Hasilnya", [])
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}


export const getAmelPerencanaan = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      var hasil = []
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://www.lpse.bondowosokab.go.id/eproc4/amel/perencanaan/detail')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="activeSatker"]', 'Semua Satuan Kerja');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          await page.select('select[name="tblperencanaandetail_length"]', '-1');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const resulttabel1 = await page.$eval('#tblperencanaandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          resulttabel1.splice(0,1)
          const resulttabel2 = await page.$eval('#tblperencanaandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          resulttabel2.splice(0,1)
          // console.log(resulttabel2)
          // for(var x=0;x<resulttabel1.length;x++){
          var _temppaketperencanaan = []
          var _temppaketpemilihan = []
          // for(var x=0;x<1;x++){
          for(var x=10394;x<resulttabel1.length;x++){
          // for(var x=18;x<19;x++){
          // for(var x=19;x<resulttabel1.length;x++){
            console.log('mulai : ' + x)
            const page2 = await browser.newPage();
            await page2.goto(urlawal + resulttabel1[x][2].match(/href="([^"]*)/)[1]);
            await delay(1000)
            var namainstansi, satuankerja, paket, metodepengadaan, pagurup, idruplama, historyrup, lokasipaket
            try{
              namainstansi = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }catch{
              namainstansi = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }
            const terakhirdiupdate = (await page2.$$eval(String.raw`body > div > div.content-wrapper > div > div > div > div > div.float-right > span`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            _temppaketperencanaan.push({
              'namainstansi': namainstansi[0],
              'satuankerja': satuankerja[0],
              'paket': paket[0],
              'metodepengadaan': metodepengadaan[0],
              'pagurup': pagurup[0],
              'idruplama': idruplama[0],
              'historyrup': historyrup[0],
              'lokasipaket': lokasipaket[0]
            })
            // console.log(resulttabel2[x][0].substr(1))
            // console.log(_temppaketperencanaan[0])
              var _temphasil = []
              _temphasil.push(_temppaketperencanaan[0])
              // _temphasil.push(_temppaketpemilihan[0])
              hasil.push({
                'idrup': resulttabel2[x][0],
                'idsatker': resulttabel2[x][1].slice(0,6),
                'satuankerja': resulttabel2[x][1],
                'namapaket': resulttabel2[x][2].split('\n')[0],
                'metodepemilihan': resulttabel2[x][3],
                'tanggalpengumuman': resulttabel2[x][4],
                'tanggal_rencana_pemilihan': resulttabel2[x][5],
                'pagurup': resulttabel2[x][6],
                'detail': _temphasil
              })
              //
              const queryinsertdetail = "INSERT INTO master_amel_detail (rup,instansi,satuan_kerja,paket,metode_pengadaan,pagu_rup,id_rup_lama,history_rup,lokasi_paket,kode_paket,nama_paket,nilai_pagu_paket,nilai_hps,nilai_kontrak,jenis_transaksi,metode_pemilihan,status_paket,nama_penyedia,npwp_penyedia,tanggal_realisasi,nilai_realisasi,jadwal_pengumuman,jadwal_pemilihan,jadwal_hasil,jadwal_kontrak,jadwal_serahterima,terakhir_diupdate,status) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
              await databasesirup.query(queryinsertdetail, [resulttabel2[x][0],namainstansi[0],satuankerja[0],paket[0],metodepengadaan[0],pagurup[0],idruplama[0],historyrup[0],lokasipaket[0],'','','','','','','','','','','','','','','','','',terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : '', 'PERENCANAAN'])
              //
            //
            const queryinsertperencanaan = "INSERT INTO master_amel_perencanaan (rup, satker_id, satker, namapaket, metode_pemilihan, tanggal_pengumuman, tanggal_rencana_pemilihan, pagu_rup) VALUES (?,?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertperencanaan, [resulttabel2[x][0],resulttabel2[x][1].slice(0,6),resulttabel2[x][1],resulttabel2[x][2].split('\n')[0],resulttabel2[x][3],resulttabel2[x][4],resulttabel2[x][5],resulttabel2[x][6]])
            //
            console.log(x + ' selesai')
            await page2.close()
          }
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}

export const getAmelPersiapan = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      var hasil = []
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://www.lpse.bondowosokab.go.id/eproc4/amel/persiapan/detail')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.select('select[name="activeSatker"]', 'Semua Satuan Kerja');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          await page.select('select[name="tblpersiapandetail_length"]', '-1');
          await page.screenshot({
            path: 'screenshot9.jpg'
          });
          await delay(1000)
          const resulttabel1 = await page.$eval('#tblpersiapandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerHTML)
              ))
          resulttabel1.splice(0,1)
          const resulttabel2 = await page.$eval('#tblpersiapandetail', 
            tbody => [...tbody.rows].map(r => [...r.cells]
              .map(c =>  c.innerText)
              ))
          resulttabel2.splice(0,1)
          // console.log(resulttabel2)
          // for(var x=0;x<resulttabel1.length;x++){
          var _temppaketperencanaan = []
          var _temppaketpemilihan = []
          // for(var x=0;x<1;x++){
          for(var x=0;x<resulttabel1.length;x++){
          // for(var x=18;x<19;x++){
          // for(var x=19;x<resulttabel1.length;x++){
            console.log('mulai : ' + x)
            const page2 = await browser.newPage();
            await page2.goto(urlawal + resulttabel1[x][2].match(/href="([^"]*)/)[1]);
            await delay(1000)
            var namainstansi, satuankerja, paket, metodepengadaan, pagurup, idruplama, historyrup, lokasipaket
            try{
              namainstansi = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\34 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }catch{
              namainstansi = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                  element => element.innerText)
              )) || [''];
              satuankerja = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              paket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              metodepengadaan = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              pagurup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              idruplama = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              historyrup = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              lokasipaket = (await page2.$$eval(String.raw`#\33 ` + resulttabel2[x][0].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
            }
            console.log(resulttabel2[x][0])
            _temppaketperencanaan.push({
              'namainstansi': namainstansi[0],
              'satuankerja': satuankerja[0],
              'paket': paket[0],
              'metodepengadaan': metodepengadaan[0],
              'pagurup': pagurup[0],
              'idruplama': idruplama[0],
              'historyrup': historyrup[0],
              'lokasipaket': lokasipaket[0]
            })
            const kodepaketpemilihan = await page2.$$eval(String.raw`#collapseTwo > div > ul > li > a`, elements => elements.map(
                  element => element.innerText)
            )
            console.log(kodepaketpemilihan.length)
            for(var y=0; y<kodepaketpemilihan.length; y++){
              var kodepaket, namapaket, nilaipagupaket, nilaihps, nilaikontrak, jenistransaksi, metodepemilihan, statuspaket,tabelpenyedia, pengumumanrup, pemulihan, hasilpemilihan, kontrak, serahterima
              try{
                kodepaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\38 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }catch{
                kodepaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(1) > td`, elements => elements.map(
                    element => element.innerText)
                )) || [''];
                namapaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(2) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaipagupaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(3) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaihps = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(4) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                nilaikontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(5) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                jenistransaksi = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(6) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                metodepemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(7) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                statuspaket = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > table > tbody > tr:nth-child(8) > td`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                tabelpenyedia = await page2.$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(2) > table`, 
                  tbody => [...tbody.rows].map(r => [...r.cells]
                    .map(c =>  c.innerText)
                    ))
                pengumumanrup = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(1) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                pemulihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(2) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                hasilpemilihan = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(3) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                kontrak = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(4) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
                serahterima = (await page2.$$eval(String.raw`#\31 ` + kodepaketpemilihan[y].substr(1) +  ` > div:nth-child(3) > ul > li:nth-child(5) > div > span.float-right`, elements => elements.map(
                      element => element.innerText)
                )) || [''];
              }
              const terakhirdiupdate = (await page2.$$eval(String.raw`body > div > div.content-wrapper > div > div > div > div > div.float-right > span`, elements => elements.map(
                    element => element.innerText)
              )) || [''];
              tabelpenyedia.splice(0,1)
              _temppaketpemilihan.push({
                'kodepaket': kodepaket[0],
                'namapaket': namapaket[0],
                'nilaipagupaket': nilaipagupaket[0],
                'nilaihps': nilaihps[0],
                'nilaikontrak': nilaikontrak[0],
                'jenistransaksi': jenistransaksi[0],
                'metodepemilihan': metodepemilihan[0],
                'statuspaket': statuspaket[0],
                'tabeldetail': tabelpenyedia,
                'pengumumanrup': pengumumanrup[0],
                'pemulihan': pemulihan[0],
                'hasilpemilihan': hasilpemilihan[0],
                'kontrak': kontrak[0],
                'serahterima': serahterima[0],
                'terakhirdiupdate': terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : ''
              })
              var _temphasil = []
              _temphasil.push(_temppaketperencanaan[0])
              _temphasil.push(_temppaketpemilihan[0])
              hasil.push({
                'idrup': resulttabel2[x][0],
                'idsatker': resulttabel2[x][1].slice(0,6),
                'satuankerja': resulttabel2[x][1],
                'namapaket': resulttabel2[x][2].split('\n')[0],
                'metodepemilihan': resulttabel2[x][3],
                'tanggalbuatpaket': resulttabel2[x][4],
                'nilaipagupaket': resulttabel2[x][5],
                'detail': _temphasil
              })
              //
              const queryinsertdetail = "INSERT INTO master_amel_detail (rup,instansi,satuan_kerja,paket,metode_pengadaan,pagu_rup,id_rup_lama,history_rup,lokasi_paket,kode_paket,nama_paket,nilai_pagu_paket,nilai_hps,nilai_kontrak,jenis_transaksi,metode_pemilihan,status_paket,nama_penyedia,npwp_penyedia,tanggal_realisasi,nilai_realisasi,jadwal_pengumuman,jadwal_pemilihan,jadwal_hasil,jadwal_kontrak,jadwal_serahterima,terakhir_diupdate,status) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
              await databasesirup.query(queryinsertdetail, [resulttabel2[x][0],namainstansi[0],satuankerja[0],paket[0],metodepengadaan[0],pagurup[0],idruplama[0],historyrup[0],lokasipaket[0],kodepaket[0],namapaket[0],nilaipagupaket[0],nilaihps[0],nilaikontrak[0],jenistransaksi[0],metodepemilihan[0],statuspaket[0],tabelpenyedia.length != 0 ? tabelpenyedia[0][1] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][2] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][3] : '',tabelpenyedia.length != 0 ? tabelpenyedia[0][4] : '',pengumumanrup[0],pemulihan[0],hasilpemilihan[0],kontrak[0],serahterima[0],terakhirdiupdate[0] != '' ? terakhirdiupdate[0].substr(20) : '', 'PERSIAPAN'])
              //
            }
            //
            const queryinsertpersiapan = "INSERT INTO master_amel_persiapan (rup, satker_id, satker, namapaket, metode_pemilihan, tanggal_buat_paket, nilai_pagu_paket) VALUES (?,?,?,?,?,?,?)"
            await databasesirup.query(queryinsertpersiapan, [resulttabel2[x][0],resulttabel2[x][1].slice(0,6),resulttabel2[x][1],resulttabel2[x][2].split('\n')[0],resulttabel2[x][3],resulttabel2[x][4],resulttabel2[x][5]])
            //
            console.log(x + ' selesai')
            await page2.close()
          }
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}

export const getAmelDashboard = async (req, reply) => {
      const userAgent = new UserAgent({ deviceCategory: 'desktop' }); // You can specify the device category
      const randomUserAgent = userAgent.toString();
      // const { usernamepost, passwordpost, satkerpost, tahunpost } = req.body
      const delay = time => new Promise(res=>setTimeout(res,time));
      var urlawal = 'http://www.lpse.bondowosokab.go.id'
      const browser = await puppeteer.launch({ headless: true, defaultViewport: null,
      args: ['--start-maximized', '--no-sandbox', '--disable-infobars', '--disable-extensions', '--ignore-certificate-errors'],
      // ignoreDefaultArgs: ['--enable-automation'],
      // defaultViewport: null,  
      ignoreHTTPSErrors: true,});
      const page = await browser.newPage();
      try {
          // await page.setUserAgent('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/100.0.4896.88 Safari/537.36')
          // await page.setUserAgent(randomUserAgent)
          const navigationPromise = page.waitForNavigation({ waitUntil: "domcontentloaded" })
          await page.goto('http://www.lpse.bondowosokab.go.id/eproc4/amel')
          await navigationPromise
          await page.screenshot({
            path: 'screenshot1.jpg'
          });
          await delay(1000)
          await page.waitForSelector('body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.text-center')
          var tombols = await page.$("body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.text-center")
          await tombols.click()
          await delay(1000)
          var hasil = []
          var _tempperencanaan = []
          const perencanaantotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > span.info-box-number > h3 > b`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div:nth-child(3) > a`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpenyediapdn = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(2)`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpenyediaumk = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(3)`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpenyediatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpenyediapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanpenyediaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanswakelolatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanswakelolapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const perencanaanswakelolaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(1) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          _tempperencanaan.push({
            'perencanaantotal': perencanaantotal[0],
            'perencanaanpaket': perencanaanpaket[0],
            'perencanaanpenyediapdn': perencanaanpenyediapdn[0].replace('PDN : ', ''),
            'perencanaanpenyediaumk': perencanaanpenyediaumk[0].replace('UMK : ', ''),
            'perencanaanpenyediatotal': perencanaanpenyediatotal[0].split('/')[0],
            'perencanaanpenyediapaket': perencanaanpenyediapaket[0].split('/')[1].split('(')[0],
            'perencanaanpenyediaprogres': perencanaanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),
            'perencanaanswakelolatotal': perencanaanswakelolatotal[0].split('/')[0],
            'perencanaanswakelolapaket': perencanaanswakelolapaket[0].split('/')[1].split('(')[0],
            'perencanaanswakelolaprogres': perencanaanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')
          })
          ///////////////////////////////
          var _temppersiapan = []
          const persiapantotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > span.info-box-number > h3 > b`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div:nth-child(3) > a`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpenyediapdn = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(2)`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpenyediaumk = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(3)`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpenyediatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpenyediapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanpenyediaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanswakelolatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanswakelolapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const persiapanswakelolaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(2) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          _temppersiapan.push({
            'persiapantotal': persiapantotal[0],
            'persiapanpaket': persiapanpaket[0],
            'persiapanpenyediapdn': persiapanpenyediapdn[0].replace('PDN : ', ''),
            'persiapanpenyediaumk': persiapanpenyediaumk[0].replace('UMK : ', ''),
            'persiapanpenyediatotal': persiapanpenyediatotal[0].split('/')[0],
            'persiapanpenyediapaket': persiapanpenyediapaket[0].split('/')[1].split('(')[0],
            'persiapanpenyediaprogres': persiapanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),
            'persiapanswakelolatotal': persiapanswakelolatotal[0].split('/')[0],
            'persiapanswakelolapaket': persiapanswakelolapaket[0].split('/')[1].split('(')[0],
            'persiapanswakelolaprogres': persiapanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')
          })
          ///////////////////////////////
          var _temppemilihan = []
          const pemilihantotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > span.info-box-number > h3 > b > h3`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div:nth-child(3) > a`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpenyediapdn = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(2)`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpenyediaumk = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(3)`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpenyediatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpenyediapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanpenyediaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanswakelolatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanswakelolapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const pemilihanswakelolaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(3) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          _temppemilihan.push({
            'pemilihantotal': pemilihantotal[0],
            'pemilihanpaket': pemilihanpaket[0],
            'pemilihanpenyediapdn': pemilihanpenyediapdn[0].replace('PDN : ', ''),
            'pemilihanpenyediaumk': pemilihanpenyediaumk[0].replace('UMK : ', ''),
            'pemilihanpenyediatotal': pemilihanpenyediatotal[0].split('/')[0],
            'pemilihanpenyediapaket': pemilihanpenyediapaket[0].split('/')[1].split('(')[0],
            'pemilihanpenyediaprogres': pemilihanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),
            'pemilihanswakelolatotal': pemilihanswakelolatotal[0].split('/')[0],
            'pemilihanswakelolapaket': pemilihanswakelolapaket[0].split('/')[1].split('(')[0],
            'pemilihanswakelolaprogres': pemilihanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')
          })
          ///////////////////////////////
          var _tempkontrak = []
          const kontraktotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > span.info-box-number > h3 > b`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div:nth-child(3) > a`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpenyediapdn = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(2)`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpenyediaumk = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(3)`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpenyediatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpenyediapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakpenyediaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakswakelolatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakswakelolapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const kontrakswakelolaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(4) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(8) > i`, elements => elements.map(
                  element => element.innerText)
            )
          _tempkontrak.push({
            'kontraktotal': kontraktotal[0],
            'kontrakpaket': kontrakpaket[0],
            'kontrakpenyediapdn': kontrakpenyediapdn[0].replace('PDN : ', ''),
            'kontrakpenyediaumk': kontrakpenyediaumk[0].replace('UMK : ', ''),
            'kontrakpenyediatotal': kontrakpenyediatotal[0].split('/')[0],
            'kontrakpenyediapaket': kontrakpenyediapaket[0].split('/')[1].split('(')[0],
            'kontrakpenyediaprogres': kontrakpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),
            'kontrakswakelolatotal': kontrakswakelolatotal[0].split('/')[0],
            'kontrakswakelolapaket': kontrakswakelolapaket[0].split('/')[1].split('(')[0],
            'kontrakswakelolaprogres': kontrakswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')
          })
          ///////////////////////////////
          var _tempserahterima = []
          const serahterimatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > span.info-box-number > h3 > b > h3`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div:nth-child(3) > a`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapenyediapdn = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(2)`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapenyediaumk = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(3)`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapenyediatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapenyediapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimapenyediaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(5) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimaswakelolatotal = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimaswakelolapaket = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          const serahterimaswakelolaprogres = await page.$$eval(String.raw`body > div > div.content-wrapper > section:nth-child(3) > div.col-md-12 > div > div:nth-child(5) > div > div > div.collapseSummaryBox.collapse.show > span:nth-child(9) > i`, elements => elements.map(
                  element => element.innerText)
            )
          _tempserahterima.push({
            'serahterimatotal': serahterimatotal[0],
            'serahterimapaket': serahterimapaket[0],
            'serahterimapenyediapdn': serahterimapenyediapdn[0].replace('PDN : ', ''),
            'serahterimapenyediaumk': serahterimapenyediaumk[0].replace('UMK : ', ''),
            'serahterimapenyediatotal': serahterimapenyediatotal[0].split('/')[0],
            'serahterimapenyediapaket': serahterimapenyediapaket[0].split('/')[1].split('(')[0],
            'serahterimapenyediaprogres': serahterimapenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),
            'serahterimaswakelolatotal': serahterimaswakelolatotal[0].split('/')[0],
            'serahterimaswakelolapaket': serahterimaswakelolapaket[0].split('/')[1].split('(')[0],
            'serahterimaswakelolaprogres': serahterimaswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')
          })
          hasil.push({
            'perencanaan': _tempperencanaan,
            'persiapan': _temppersiapan,
            'pemilihan': _temppemilihan,
            'kontrak': _tempkontrak,
            'serahterima': _tempserahterima
          })
          console.log('berhasil')
          const queryinsert = "INSERT INTO sirefik_dashboard (perencanaan_total,perencanaan_paket,perencanaan_penyedia_pdn,perencanaan_penyedia_umk,perencanaan_penyedia_total,perencanaan_penyedia_paket,perencanaan_penyedia_progress,perencanaan_swakelola_total,perencanaan_swakelola_paket,perencanaan_swakelola_progress,persiapan_total,persiapan_paket,persiapan_penyedia_pdn,persiapan_penyedia_umk,persiapan_penyedia_total,persiapan_penyedia_paket,persiapan_penyedia_progress,persiapan_swakelola_total,persiapan_swakelola_paket,persiapan_swakelola_progress,pemilihan_total,pemilihan_paket,pemilihan_penyedia_pdn,pemilihan_penyedia_umk,pemilihan_penyedia_total,pemilihan_penyedia_paket,pemilihan_penyedia_progress,pemilihan_swakelola_total,pemilihan_swakelola_paket,pemilihan_swakelola_progress,kontrak_total,kontrak_paket,kontrak_penyedia_pdn,kontrak_penyedia_umk,kontrak_penyedia_total,kontrak_penyedia_paket,kontrak_penyedia_progress,kontrak_swakelola_total,kontrak_swakelola_paket,kontrak_swakelola_progress,serahterima_total,serahterima_paket,serahterima_penyedia_pdn,serahterima_penyedia_umk,serahterima_penyedia_total,serahterima_penyedia_paket,serahterima_penyedia_progress,serahterima_swakelola_total,serahterima_swakelola_paket,serahterima_swakelola_progress) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
          await databasesirup.query(queryinsert,[perencanaantotal[0],perencanaanpaket[0],perencanaanpenyediapdn[0].replace('PDN : ', ''),perencanaanpenyediaumk[0].replace('UMK : ', ''),perencanaanpenyediatotal[0].split('/')[0],perencanaanpenyediapaket[0].split('/')[1].split('(')[0],perencanaanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),perencanaanswakelolatotal[0].split('/')[0],perencanaanswakelolapaket[0].split('/')[1].split('(')[0],perencanaanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),persiapantotal[0],persiapanpaket[0],persiapanpenyediapdn[0].replace('PDN : ', ''),persiapanpenyediaumk[0].replace('UMK : ', ''),persiapanpenyediatotal[0].split('/')[0],persiapanpenyediapaket[0].split('/')[1].split('(')[0],persiapanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),persiapanswakelolatotal[0].split('/')[0],persiapanswakelolapaket[0].split('/')[1].split('(')[0],persiapanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),pemilihantotal[0],pemilihanpaket[0],pemilihanpenyediapdn[0].replace('PDN : ', ''),pemilihanpenyediaumk[0].replace('UMK : ', ''),pemilihanpenyediatotal[0].split('/')[0],pemilihanpenyediapaket[0].split('/')[1].split('(')[0],pemilihanpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),pemilihanswakelolatotal[0].split('/')[0],pemilihanswakelolapaket[0].split('/')[1].split('(')[0],pemilihanswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),kontraktotal[0],kontrakpaket[0],kontrakpenyediapdn[0].replace('PDN : ', ''),kontrakpenyediaumk[0].replace('UMK : ', ''),kontrakpenyediatotal[0].split('/')[0],kontrakpenyediapaket[0].split('/')[1].split('(')[0],kontrakpenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),kontrakswakelolatotal[0].split('/')[0],kontrakswakelolapaket[0].split('/')[1].split('(')[0],kontrakswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),serahterimatotal[0],serahterimapaket[0],serahterimapenyediapdn[0].replace('PDN : ', ''),serahterimapenyediaumk[0].replace('UMK : ', ''),serahterimapenyediatotal[0].split('/')[0],serahterimapenyediapaket[0].split('/')[1].split('(')[0],serahterimapenyediaprogres[0].split('paket')[1].replace('(', '').replace(')', ''),serahterimaswakelolatotal[0].split('/')[0],serahterimaswakelolapaket[0].split('/')[1].split('(')[0],serahterimaswakelolaprogres[0].split('paket')[1].replace('(', '').replace(')', '')])
          return toJson(reply, 200, "Hasilnya", hasil)
      } catch (e) {
          return toJson(reply, 500, "Website Down", [])
      }
}