export const toJson = (reply, code, message, data = []) => {
    var metadata = {} 

    metadata['code'] = code
    metadata['status'] = generateStatus(code)
    metadata['message'] = message

    var response = {}
    response['data'] = data

    var Response = {
        metadata,
        response
    }

    var response = reply.status(code).send(Response)

    return response
}

const generateStatus = (code) => {
    switch (code) {
        case 200:
            var status = "OK"
            break
        case 201:
            var status = "ERR_REQUIRED"
            break
        case 404:
            var status = "ERR_NOT_FOUND"
            break
        case 500:
            var status = "ERR_INTERNAL"
            break
        default:
            var status = "UNKNOWN"
            break
    }

    return status
}
