import { Router } from "express";
import {
  getSirup, getAmelPemilihan, getAmelHasilPemilihan, getAmelKontrak, getSirupMapping, getAmelPerencanaan,
  getAmelPersiapan, getAmelDashboard
} from "../controllers/sirup_controller.js";
const router = Router();

router.post("/getSirup", getSirup)
router.get("/getAmelPemilihan", getAmelPemilihan)
router.get("/getAmelHasilPemilihan", getAmelHasilPemilihan)
router.get("/getAmelKontrak", getAmelKontrak)
router.get("/getSirupMapping", getSirupMapping)
router.get("/getAmelPerencanaan", getAmelPerencanaan)
router.get("/getAmelPersiapan", getAmelPersiapan)
router.get("/getAmelDashboard", getAmelDashboard)

export default router;
